#ifndef NL_NL_PROTO_H
#define NL_NL_PROTO_H

/***********************************************************************
The "extern C" protection around these function prototypes is to allow
the (unlikely) occurence of use by C applications.  Since presence of
the networking functions requires additional link libraries on some
platforms, these C functions are here and not in OSD to keep the
impact of using OSD low.  Since most users are in actuality going to
use C++, these functions are kept in libnl.a and not put into their
own special, C library.  WARNING: Any functions added to this file
can *NOT* access any classes.
***********************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

/* channel.cc */

/* nltest.cc */
/* int main(int argc,char **argv,char **envp); */

/* system.cc */
#if OSD_COMPILER==OSD_KR
uint16 nlGetServicePort();
long nlGetServiceName();
int nlGetServerHostname();
NL_HOST_INET_ADDR nlGetServerAddress(c);
NL_HOST_INET_ADDR nlGetHostAddress();
void nlUnaliasHostname();
int nlIoctl();
int nlIoctl();
long nlGetHostName();
#else
uint16 nlGetServicePort(char *service_name, char *protocol_name);
long nlGetServiceName(char *servicename, long servicename_length, uint16 port, char *protocol);
int nlGetServerHostname(char *hostname, int hostname_length, NL_HOST_INET_ADDR address);
NL_HOST_INET_ADDR nlGetServerAddress(const char *nodename);
NL_HOST_INET_ADDR nlGetHostAddress(void);
void nlUnaliasHostname(char *hostname, int hostname_length);
int nlIoctl(SOCKET_HANDLE_T s, long cmd, char *arg);
int nlIoctl(SOCKET_HANDLE_T fildes, long request, char *arg);
long nlGetHostName(char *hostname, long hostname_length);
#endif


/* support.cc */
#if OSD_COMPILER==OSD_KR
void nlPrint();
void nlInetAddrToString();
NL_HOST_INET_ADDR nlStringToInetAddr();
uint32 nlIpSocketStartup();
uint32 nlIpSocketCleanup();
#else
void nlPrint(long source, long type, char *message, char *file, long line);
void nlInetAddrToString(char *string, int length, NL_HOST_INET_ADDR address);
NL_HOST_INET_ADDR nlStringToInetAddr(const char *string);
uint32 nlIpSocketStartup(void);
uint32 nlIpSocketCleanup(void);
#endif

#ifdef __cplusplus
}
#endif

#endif /* NL_NL_PROTO_H */
